/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gdexpress.demofacturador.vista;

import DocumentoDTE.SiiDte.Detalle;
import DocumentoDTE.SiiDte.Referencia;
import com.liquid_technologies.ltxmllib12.DateTime;
import com.liquid_technologies.ltxmllib12.exceptions.LtException;
import gdexpress.demofacturador.lib.AsistenteEnum;
import gdexpress.demofacturador.lib.Documento;
import gdexpress.demofacturador.lib.InfoMostrar;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

/**
 * Formulario de entrada de datos para generar un Documento.
 * 
 * @author yrios
 */
public class DocumentoJInternalFrame extends javax.swing.JInternalFrame {

    /**
     * Documento
     */
    private Documento documento;
    //private int referenciaSeleccionada;
    //private int detalleSeleccionado;
    private HashMap definicionesValidacion = new HashMap();

    public HashMap getDefinicionesValidacion() {
        return definicionesValidacion;
    }

    public void setDefinicionesValidacion(HashMap definicionesValidacion) {
        this.definicionesValidacion = definicionesValidacion;
    }

    public Documento getDocumento() {
        return documento;
    }

    public void setDocumento(Documento documento) {
        this.documento = documento;
    }
    
    /**
     * Creates new form DocumentoJInternalFrame
     */
    public DocumentoJInternalFrame() {
        try {
            initComponents();
            dateFchEmis.setValue(new Date());
            dateFchRef.setValue(new Date());
            
            dataGridDetalles_BotonEliminar.setEnabled(false);
            dataGridReferencia_BotonEliminar.setEnabled(false);
            
            dataGridReferencia.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            dataGridDetalles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            
            ListSelectionModel modeloSeleccionRef = dataGridReferencia.getSelectionModel();
            modeloSeleccionRef.addListSelectionListener(getListSelectionListener("Referencia"));
            
            ListSelectionModel modeloSeleccionDet = dataGridDetalles.getSelectionModel();
            modeloSeleccionDet.addListSelectionListener(getListSelectionListener("Detalle"));
            
            UtilIU.llenarComboDesdeEnum(comboIndExe, DocumentoDTE.SiiDte.Detalle_IndExe.class);
            UtilIU.llenarComboDesdeLista(comboUnmdItem, AsistenteEnum.listaUnidadMedida());
            String[] coDoc = new String[] { "30", "32", "33", "34", "46", "52", "61", "56" };
            List ListCodDoc = Arrays.asList(coDoc);
            UtilIU.llenarComboDesdeLista(comboTipoDTE, AsistenteEnum.listaTipoDocumento(ListCodDoc));
            UtilIU.llenarComboDesdeLista(comboTpoDocRef, AsistenteEnum.listaTipoDocumento(ListCodDoc));
            documento = new Documento();
            
            // Definiciones de validación
            definirValidaciones();
            
            
        } catch (LtException ex) {
            Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showConfirmDialog(null, "Error inicializando Formulario de Documento.", "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        }
    }
    
    /**
     *  
     */
    private void definirValidaciones() {
        // textRUTEmisor
        
        HashMap reglasTextRUTEmisor = new HashMap();
        reglasTextRUTEmisor.put("req", Boolean.TRUE);
        reglasTextRUTEmisor.put("rut", Boolean.TRUE);
        definicionesValidacion.put("textRUTEmisor", new Validacion("RUT del Emisor", "Encabezado", reglasTextRUTEmisor));
        
        // textRznSocEmis
        HashMap reglasTextRznSocEmis = new HashMap();
        reglasTextRznSocEmis.put("req", Boolean.TRUE);
        definicionesValidacion.put("textRznSocEmis", new Validacion("Razón social del Emisor", "Encabezado", reglasTextRznSocEmis));
        
        // textGiroEmis
        HashMap reglasTextGiroEmis = new HashMap();
        reglasTextGiroEmis.put("req", Boolean.TRUE);
        definicionesValidacion.put("textGiroEmis", new Validacion("Giro del Emisor", "Encabezado", reglasTextGiroEmis));
        
        // textDirOrigen
        HashMap reglasTextDirOrigen = new HashMap();
        reglasTextDirOrigen.put("req", Boolean.TRUE);
        definicionesValidacion.put("textDirOrigen", new Validacion("Dirección del Emisor", "Encabezado", reglasTextDirOrigen));
        
        // textCmnaOrigen
        HashMap reglasTextCmnaOrigen = new HashMap();
        reglasTextCmnaOrigen.put("req", Boolean.TRUE);
        definicionesValidacion.put("textCmnaOrigen", new Validacion("Comuna del Emisor", "Encabezado", reglasTextCmnaOrigen));
        
        // textCiudadOrigen
        HashMap reglasTextCiudadOrigen = new HashMap();
        reglasTextCiudadOrigen.put("req", Boolean.TRUE);
        definicionesValidacion.put("textCiudadOrigen", new Validacion("Ciudad del Emisor", "Encabezado", reglasTextCiudadOrigen));
        
        // textActeco
        HashMap reglasTextActeco = new HashMap();
        reglasTextActeco.put("req", Boolean.TRUE);
        reglasTextActeco.put("acteco", Boolean.TRUE);
        definicionesValidacion.put("textActeco", new Validacion("Acteco del Emisor", "Encabezado", reglasTextActeco));
        
        // textRUTRecep
        HashMap reglasTextRUTRecep = new HashMap();
        reglasTextRUTRecep.put("req", Boolean.TRUE);
        reglasTextRUTRecep.put("rut", Boolean.TRUE);
        definicionesValidacion.put("textRUTRecep", new Validacion("RUT del Cliente", "Encabezado", reglasTextRUTRecep));
        
        // textRznSocRecep
        HashMap reglasTextRznSocRecep = new HashMap();
        reglasTextRznSocRecep.put("req", Boolean.TRUE);
        definicionesValidacion.put("textRznSocRecep", new Validacion("Razón social del Cliente", "Encabezado", reglasTextRznSocRecep));
        
        // textGiroRecep
        HashMap reglasTextGiroRecep = new HashMap();
        reglasTextGiroRecep.put("req", Boolean.TRUE);
        definicionesValidacion.put("textGiroRecep", new Validacion("Giro del Cliente", "Encabezado", reglasTextGiroRecep));
        
        // textDirRecep
        HashMap reglasTextDirRecep = new HashMap();
        reglasTextDirRecep.put("req", Boolean.TRUE);
        definicionesValidacion.put("textDirRecep", new Validacion("Dirección del Cliente", "Encabezado", reglasTextDirRecep));
        
        // textCmnaRecep
        HashMap reglasTextCmnaRecep = new HashMap();
        reglasTextCmnaRecep.put("req", Boolean.TRUE);
        definicionesValidacion.put("textCmnaRecep", new Validacion("Comuna del Cliente", "Encabezado", reglasTextCmnaRecep));
        
        // textCiudadRecep
        HashMap reglasTextCiudadRecep = new HashMap();
        reglasTextCiudadRecep.put("req", Boolean.TRUE);
        definicionesValidacion.put("textCiudadRecep", new Validacion("Ciudad del Cliente", "Encabezado", reglasTextCiudadRecep));
        
        // textFolio
        HashMap reglasTextFolio = new HashMap();
        reglasTextFolio.put("req", Boolean.TRUE);
        reglasTextFolio.put("num", Boolean.TRUE);
        reglasTextFolio.put("min", new Integer(1));
        definicionesValidacion.put("textFolio", new Validacion("Folio", "Encabezado", reglasTextFolio));
        
        // textIpDteBox
        HashMap reglasTextIpDteBox = new HashMap();
        reglasTextIpDteBox.put("req", Boolean.TRUE);
        definicionesValidacion.put("textIpDteBox", new Validacion("IP DTEBOX", "Encabezado", reglasTextIpDteBox));
        
        // textLlaveAutenticacion
        HashMap reglasTextLlaveAutenticacion = new HashMap();
        reglasTextLlaveAutenticacion.put("req", Boolean.TRUE);
        definicionesValidacion.put("textLlaveAutenticacion", new Validacion("Llave de Autenticación", "Encabezado", reglasTextLlaveAutenticacion));
        
        // dateFchEmis
        HashMap reglasDateFchEmis = new HashMap();
        reglasDateFchEmis.put("req", Boolean.TRUE);
        definicionesValidacion.put("dateFchEmis", new Validacion("Fecha de Emisión", "Encabezado", reglasDateFchEmis));
        
        // textMntTotal
        HashMap reglasTextMntTotal = new HashMap();
        reglasTextMntTotal.put("req", Boolean.TRUE);
        reglasTextMntTotal.put("num", Boolean.TRUE);
        reglasTextMntTotal.put("min", new Integer(0));
        definicionesValidacion.put("textMntTotal", new Validacion("Monto Total", "Encabezado", reglasTextMntTotal));
        
        // dataGridDetalles
        HashMap reglasDataGridDetalles = new HashMap();
        reglasDataGridDetalles.put("req", Boolean.TRUE);
        definicionesValidacion.put("dataGridDetalles", new Validacion("Detalle", "Detalles", reglasDataGridDetalles));
        
        // textNmbItem
        HashMap reglasTextNmbItem = new HashMap();
        reglasTextNmbItem.put("req", Boolean.TRUE);
        definicionesValidacion.put("textNmbItem", new Validacion("Nombre", "Detalle", reglasTextNmbItem));
        
        // textQtyItem
        HashMap reglasTextQtyItem = new HashMap();
        reglasTextQtyItem.put("req", Boolean.TRUE);
        reglasTextQtyItem.put("num", Boolean.TRUE);
        reglasTextQtyItem.put("min", "0.000001");
        definicionesValidacion.put("textQtyItem", new Validacion("Cantidad", "Detalle", reglasTextQtyItem));
        
        // textPrcItem
        HashMap reglasTextPrcItem = new HashMap();
        reglasTextPrcItem.put("req", Boolean.TRUE);
        reglasTextPrcItem.put("num", Boolean.TRUE);
        reglasTextPrcItem.put("min", "0.000001");
        definicionesValidacion.put("textPrcItem", new Validacion("Precio U.", "Detalle", reglasTextPrcItem));
        
        // textMontoItem
        HashMap reglasTextMontoItem = new HashMap();
        reglasTextMontoItem.put("req", Boolean.TRUE);
        reglasTextMontoItem.put("num", Boolean.TRUE);
        reglasTextMontoItem.put("min", BigDecimal.ZERO);
        definicionesValidacion.put("textMontoItem", new Validacion("Monto", "Detalle", reglasTextMontoItem));
        
        // comboTpoDocRef
        HashMap reglasComboTpoDocRef = new HashMap();
        reglasComboTpoDocRef.put("req", Boolean.TRUE);
        definicionesValidacion.put("comboTpoDocRef", new Validacion("Tipo de documento", "Referencia", reglasComboTpoDocRef));
        
        // textFolioRef
        HashMap reglasTextFolioRef = new HashMap();
        reglasTextFolioRef.put("req", Boolean.TRUE);
        definicionesValidacion.put("textFolioRef", new Validacion("Folio", "Referencia", reglasTextFolioRef));
        
        // dateFchRef
        HashMap reglasDateFchRef = new HashMap();
        reglasDateFchRef.put("req", Boolean.TRUE);
        definicionesValidacion.put("dateFchRef", new Validacion("Fecha de Emisión", "Referencia", reglasDateFchRef));
    }
    
    /**
     * Obtiene un Listener de selección para una tabla.
     * 
     * @param tabla String tabla para la cual se va a obtener el Listener.
     * @return ListSelectionListener implementación del listener para la tabla.
     */
    private ListSelectionListener getListSelectionListener(final String tabla) {
        ListSelectionListener lsl = new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {
                    ListSelectionModel lsm = (ListSelectionModel) e.getSource();
                    if (lsm.isSelectionEmpty()) {
                        if (tabla.equals("Detalle")){
                            dataGridDetalles_BotonEliminar.setEnabled(false);
                            dataGridDetalles_BotonAdicionar.setText("Adicionar");
                            limpiarFormDetalle();
                        } else if (tabla.equals("Referencia")) {
                            dataGridReferencia_BotonEliminar.setEnabled(false);
                            dataGridReferencia_BotonAdicionar.setText("Adicionar");
                            limpiarFormReferencia();
                        }
                    } else {
                        int indiceSeleccionado = lsm.getMinSelectionIndex();
                        if (tabla.equals("Detalle")){
                            //detalleSeleccionado = indiceSeleccionado;
                            dataGridDetalles_BotonAdicionar.setText("Actualizar");
                            dataGridDetalles_BotonEliminar.setEnabled(true);
                            llenarFormDetalle(indiceSeleccionado);
                        } else if (tabla.equals("Referencia")) {
                            //referenciaSeleccionada = indiceSeleccionado;
                            dataGridReferencia_BotonAdicionar.setText("Actualizar");
                            dataGridReferencia_BotonEliminar.setEnabled(true);
                            llenarFormReferencia(indiceSeleccionado);
                        }
                    }
                }
            };
        return lsl;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        titularLabel = new javax.swing.JLabel();
        jLabelLogo = new javax.swing.JLabel();
        labEmisor = new javax.swing.JLabel();
        labRUT = new javax.swing.JLabel();
        textRUTEmisor = new javax.swing.JTextField();
        labRznSoc = new javax.swing.JLabel();
        textRznSocEmis = new javax.swing.JTextField();
        labGiroEmis = new javax.swing.JLabel();
        LabDirOrigen = new javax.swing.JLabel();
        labCmnaOrigen = new javax.swing.JLabel();
        labCiudadOrigen = new javax.swing.JLabel();
        labActeco = new javax.swing.JLabel();
        textGiroEmis = new javax.swing.JTextField();
        textDirOrigen = new javax.swing.JTextField();
        textCmnaOrigen = new javax.swing.JTextField();
        textCiudadOrigen = new javax.swing.JTextField();
        textActeco = new javax.swing.JTextField();
        labActecoEjemplo = new javax.swing.JLabel();
        labCliente = new javax.swing.JLabel();
        labRUTRecep = new javax.swing.JLabel();
        labRznSocRecep = new javax.swing.JLabel();
        labGiroRecep = new javax.swing.JLabel();
        labDirRecep = new javax.swing.JLabel();
        labCmnaRecep = new javax.swing.JLabel();
        labCiudadRecep = new javax.swing.JLabel();
        textRUTRecep = new javax.swing.JTextField();
        textRznSocRecep = new javax.swing.JTextField();
        textGiroRecep = new javax.swing.JTextField();
        textDirRecep = new javax.swing.JTextField();
        textCmnaRecep = new javax.swing.JTextField();
        textCiudadRecep = new javax.swing.JTextField();
        labIpDteBox = new javax.swing.JLabel();
        textIpDteBox = new javax.swing.JTextField();
        labFolio = new javax.swing.JLabel();
        labFchEmis = new javax.swing.JLabel();
        labMntNeto = new javax.swing.JLabel();
        labIva = new javax.swing.JLabel();
        labMntExe = new javax.swing.JLabel();
        labMntTotal = new javax.swing.JLabel();
        labTipoDTE = new javax.swing.JLabel();
        comboTipoDTE = new javax.swing.JComboBox();
        labEmisor1 = new javax.swing.JLabel();
        lblCdgItem = new javax.swing.JLabel();
        textCdgItem = new javax.swing.JTextField();
        labNmbItem = new javax.swing.JLabel();
        textNmbItem = new javax.swing.JTextField();
        labDscItem = new javax.swing.JLabel();
        textDscItem = new javax.swing.JTextField();
        labUnmdItem = new javax.swing.JLabel();
        comboUnmdItem = new javax.swing.JComboBox();
        labQtyItem = new javax.swing.JLabel();
        labPrcItem = new javax.swing.JLabel();
        labMontoItem = new javax.swing.JLabel();
        labIndExe = new javax.swing.JLabel();
        chk_comboIndExe = new javax.swing.JCheckBox();
        labIndExe1 = new javax.swing.JLabel();
        comboIndExe = new javax.swing.JComboBox();
        dataGridDetalles_BotonAdicionar = new javax.swing.JButton();
        dataGridDetalles_BotonEliminar = new javax.swing.JButton();
        dataGridDetalles_BotonLimpiar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataGridDetalles = new javax.swing.JTable();
        labReferencias = new javax.swing.JLabel();
        labTpoDocRef = new javax.swing.JLabel();
        comboTpoDocRef = new javax.swing.JComboBox();
        labFolioRef = new javax.swing.JLabel();
        textFolioRef = new javax.swing.JTextField();
        labFchRef = new javax.swing.JLabel();
        labRazonRef = new javax.swing.JLabel();
        textRazonRef = new javax.swing.JTextField();
        labComentario = new javax.swing.JLabel();
        textComentarioRef = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        dataGridReferencia = new javax.swing.JTable();
        dataGridReferencia_BotonAdicionar = new javax.swing.JButton();
        dataGridReferencia_BotonEliminar = new javax.swing.JButton();
        dataGridReferencia_BotonLimpiar = new javax.swing.JButton();
        btnCerrar = new javax.swing.JButton();
        btnSalvar = new javax.swing.JButton();
        dateFchEmis = new javax.swing.JFormattedTextField();
        textFolio = new javax.swing.JFormattedTextField();
        textMntNeto = new javax.swing.JFormattedTextField();
        textIva = new javax.swing.JFormattedTextField();
        textMntExe = new javax.swing.JFormattedTextField();
        textMntTotal = new javax.swing.JFormattedTextField();
        textQtyItem = new javax.swing.JFormattedTextField();
        textPrcItem = new javax.swing.JFormattedTextField();
        textMontoItem = new javax.swing.JFormattedTextField();
        dateFchRef = new javax.swing.JFormattedTextField();
        textLlaveAutenticacion = new javax.swing.JTextField();
        labLlaveAutenticacion = new javax.swing.JLabel();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setTitle("Documento");
        setToolTipText("");
        setMinimumSize(new java.awt.Dimension(0, 0));
        setPreferredSize(new java.awt.Dimension(1024, 768));

        titularLabel.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 18)); // NOI18N
        titularLabel.setText("Facturador DEMO");

        jLabelLogo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/logo130x19.png"))); // NOI18N

        labEmisor.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 14)); // NOI18N
        labEmisor.setText("* Emisor:");
        labEmisor.setToolTipText("");

        labRUT.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labRUT.setText("* RUT:");

        textRUTEmisor.setName("textRUTEmisor"); // NOI18N

        labRznSoc.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labRznSoc.setText("* Razón Social:");

        textRznSocEmis.setName("textRznSocEmis"); // NOI18N

        labGiroEmis.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labGiroEmis.setText("* Giro:");

        LabDirOrigen.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        LabDirOrigen.setText("* Dirección:");

        labCmnaOrigen.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labCmnaOrigen.setText("* Comuna:");

        labCiudadOrigen.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labCiudadOrigen.setText("* Ciudad:");

        labActeco.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labActeco.setText("* Acteco:");

        textGiroEmis.setName("textGiroEmis"); // NOI18N

        textDirOrigen.setName("textDirOrigen"); // NOI18N

        textCmnaOrigen.setName("textCmnaOrigen"); // NOI18N

        textCiudadOrigen.setName("textCiudadOrigen"); // NOI18N

        textActeco.setName("textActeco"); // NOI18N

        labActecoEjemplo.setFont(new java.awt.Font("MS Reference Sans Serif", 2, 10)); // NOI18N
        labActecoEjemplo.setForeground(new java.awt.Color(0, 0, 204));
        labActecoEjemplo.setText("Ej: 1234,5678,8754");

        labCliente.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 14)); // NOI18N
        labCliente.setText("* Cliente:");
        labCliente.setToolTipText("");

        labRUTRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labRUTRecep.setText("* RUT:");

        labRznSocRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labRznSocRecep.setText("* Razón Social:");

        labGiroRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labGiroRecep.setText("* Giro:");

        labDirRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labDirRecep.setText("* Dirección:");

        labCmnaRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labCmnaRecep.setText("* Comuna:");

        labCiudadRecep.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labCiudadRecep.setText("* Ciudad:");

        textRUTRecep.setName("textRUTRecep"); // NOI18N

        textRznSocRecep.setName("textRznSocRecep"); // NOI18N

        textGiroRecep.setName("textGiroRecep"); // NOI18N

        textDirRecep.setName("textDirRecep"); // NOI18N

        textCmnaRecep.setName("textCmnaRecep"); // NOI18N

        textCiudadRecep.setName("textCiudadRecep"); // NOI18N

        labIpDteBox.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labIpDteBox.setText("* IP DTEBOX:");

        textIpDteBox.setName("textIpDteBox"); // NOI18N

        labFolio.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labFolio.setText("* Folio:");

        labFchEmis.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labFchEmis.setText("* Fecha de Emisión:");

        labMntNeto.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labMntNeto.setText("Monto Neto:");

        labIva.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labIva.setText("IVA:");

        labMntExe.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labMntExe.setText("Monto Exento:");

        labMntTotal.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labMntTotal.setText("* Monto Total:");

        labTipoDTE.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 12)); // NOI18N
        labTipoDTE.setText("* Tipo DTE:");

        comboTipoDTE.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        comboTipoDTE.setName("comboTipoDTE"); // NOI18N

        labEmisor1.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 14)); // NOI18N
        labEmisor1.setText("* Detalle");
        labEmisor1.setToolTipText("");

        lblCdgItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        lblCdgItem.setText("Código:");

        labNmbItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labNmbItem.setText("* Nombre:");

        textNmbItem.setName("textNmbItem"); // NOI18N

        labDscItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labDscItem.setText("Descripción:");

        labUnmdItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labUnmdItem.setText("U. medida:");

        comboUnmdItem.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        labQtyItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labQtyItem.setText("* Cantidad:");

        labPrcItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labPrcItem.setText("* Precio U.:");

        labMontoItem.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labMontoItem.setText("* Monto:");

        labIndExe.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labIndExe.setText("Exento:");

        chk_comboIndExe.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chk_comboIndExeActionPerformed(evt);
            }
        });

        labIndExe1.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labIndExe1.setText("Indicador Exento:");

        comboIndExe.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        comboIndExe.setEnabled(false);

        dataGridDetalles_BotonAdicionar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/semaforo_green.png"))); // NOI18N
        dataGridDetalles_BotonAdicionar.setText("Adicionar");
        dataGridDetalles_BotonAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridDetalles_BotonAdicionarActionPerformed(evt);
            }
        });

        dataGridDetalles_BotonEliminar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/cross.png"))); // NOI18N
        dataGridDetalles_BotonEliminar.setText("Eliminar");
        dataGridDetalles_BotonEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridDetalles_BotonEliminarActionPerformed(evt);
            }
        });

        dataGridDetalles_BotonLimpiar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/minus_l.png"))); // NOI18N
        dataGridDetalles_BotonLimpiar.setText("Limpiar");
        dataGridDetalles_BotonLimpiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridDetalles_BotonLimpiarActionPerformed(evt);
            }
        });

        dataGridDetalles.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Código", "* Nombre", "Descripción", "U. medida", "* Cantidad", "* Precio U.", "* Monto", "Indicador Exento"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        dataGridDetalles.setName("dataGridDetalles"); // NOI18N
        jScrollPane1.setViewportView(dataGridDetalles);

        labReferencias.setFont(new java.awt.Font("MS Reference Sans Serif", 1, 14)); // NOI18N
        labReferencias.setText("Referencias");
        labReferencias.setToolTipText("");

        labTpoDocRef.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labTpoDocRef.setText("* Tipo de Documento:");

        comboTpoDocRef.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        comboTpoDocRef.setName("comboTpoDocRef"); // NOI18N

        labFolioRef.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labFolioRef.setText("* Folio:");

        textFolioRef.setName("textFolioRef"); // NOI18N

        labFchRef.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labFchRef.setText("* Fecha de Emisión:");

        labRazonRef.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labRazonRef.setText("Razón de referencia:");

        labComentario.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labComentario.setText("Comentario:");

        dataGridReferencia.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "* Tipo de Documento", "* Folio", "Fecha de Emisión", "Razón de referencia", "Comentario"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(dataGridReferencia);

        dataGridReferencia_BotonAdicionar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/semaforo_green.png"))); // NOI18N
        dataGridReferencia_BotonAdicionar.setText("Adicionar");
        dataGridReferencia_BotonAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridReferencia_BotonAdicionarActionPerformed(evt);
            }
        });

        dataGridReferencia_BotonEliminar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/cross.png"))); // NOI18N
        dataGridReferencia_BotonEliminar.setText("Eliminar");
        dataGridReferencia_BotonEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridReferencia_BotonEliminarActionPerformed(evt);
            }
        });

        dataGridReferencia_BotonLimpiar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/minus_l.png"))); // NOI18N
        dataGridReferencia_BotonLimpiar.setText("Limpiar");
        dataGridReferencia_BotonLimpiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataGridReferencia_BotonLimpiarActionPerformed(evt);
            }
        });

        btnCerrar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/cross.png"))); // NOI18N
        btnCerrar.setText("Cerrar");
        btnCerrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCerrarActionPerformed(evt);
            }
        });

        btnSalvar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/semaforo_green.png"))); // NOI18N
        btnSalvar.setText("Generar XML");
        btnSalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalvarActionPerformed(evt);
            }
        });

        dateFchEmis.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.DateFormatter(new java.text.SimpleDateFormat("d/M/yy"))));
        dateFchEmis.setToolTipText("Día/Mes/Año");
        dateFchEmis.setName("dateFchEmis"); // NOI18N

        textFolio.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textFolio.setName("textFolio"); // NOI18N

        textMntNeto.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textMntNeto.setName("textMntNeto"); // NOI18N

        textIva.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textIva.setName("textIva"); // NOI18N

        textMntExe.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textMntExe.setName("textMntExe"); // NOI18N

        textMntTotal.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textMntTotal.setName("textMntTotal"); // NOI18N

        textQtyItem.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0.000000"))));
        textQtyItem.setName("textQtyItem"); // NOI18N
        textQtyItem.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                textQtyItemPropertyChange(evt);
            }
        });

        textPrcItem.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0.000000"))));
        textPrcItem.setName("textPrcItem"); // NOI18N
        textPrcItem.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                textPrcItemPropertyChange(evt);
            }
        });

        textMontoItem.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
        textMontoItem.setName("textMontoItem"); // NOI18N

        dateFchRef.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.DateFormatter(new java.text.SimpleDateFormat("d/M/yy"))));
        dateFchRef.setToolTipText("Día/Mes/Año");
        dateFchRef.setName("dateFchRef"); // NOI18N

        textLlaveAutenticacion.setName("textLlaveAutenticacion"); // NOI18N

        labLlaveAutenticacion.setFont(new java.awt.Font("MS Reference Sans Serif", 0, 12)); // NOI18N
        labLlaveAutenticacion.setText("* Llave de Autenticación:");
        labLlaveAutenticacion.setName("labLlaveAutenticacion"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(dataGridReferencia_BotonAdicionar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(dataGridReferencia_BotonEliminar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(dataGridReferencia_BotonLimpiar)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                                .addComponent(lblCdgItem)
                                                .addGap(32, 32, 32)
                                                .addComponent(labNmbItem))
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(labEmisor)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(labCiudadOrigen)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(textCiudadOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(labCmnaOrigen)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(textCmnaOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(LabDirOrigen)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(textDirOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(labGiroEmis)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(textGiroEmis, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                                        .addComponent(labRUT)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(textRUTEmisor, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                                        .addComponent(labRznSoc)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(textRznSocEmis, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(labActeco)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addComponent(labActecoEjemplo)
                                                            .addComponent(textActeco, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))))))
                                        .addGap(37, 37, 37)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(labCliente)
                                            .addGroup(layout.createSequentialGroup()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(labRznSocRecep)
                                                    .addComponent(labRUTRecep)
                                                    .addComponent(labGiroRecep)
                                                    .addComponent(labDirRecep)
                                                    .addComponent(labCmnaRecep)
                                                    .addComponent(labCiudadRecep))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(textCiudadRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(textCmnaRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(textDirRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(textGiroRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(textRUTRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(textRznSocRecep, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                        .addGap(26, 26, 26)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addGroup(layout.createSequentialGroup()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(labMntNeto)
                                                    .addComponent(labIva)
                                                    .addComponent(labMntExe)
                                                    .addComponent(labFchEmis)
                                                    .addComponent(labFolio)
                                                    .addComponent(labLlaveAutenticacion)
                                                    .addComponent(labIpDteBox))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                                    .addComponent(textIva, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(textIpDteBox, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addComponent(textLlaveAutenticacion, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addComponent(textFolio, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addComponent(dateFchEmis, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addComponent(textMntNeto, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addComponent(textMntExe, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                            .addGroup(layout.createSequentialGroup()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(labMntTotal)
                                                    .addComponent(labTipoDTE))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(textMntTotal, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(comboTipoDTE, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(comboTpoDocRef, javax.swing.GroupLayout.PREFERRED_SIZE, 195, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(textFolioRef, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(dateFchRef, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(textRazonRef, javax.swing.GroupLayout.PREFERRED_SIZE, 218, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(textComentarioRef, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(textCdgItem, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(textNmbItem, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(textDscItem, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labDscItem))
                                        .addGap(18, 18, 18)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(comboUnmdItem, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(18, 18, 18)
                                                .addComponent(textQtyItem, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(textPrcItem, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(labUnmdItem)
                                                .addGap(54, 54, 54)
                                                .addComponent(labQtyItem)
                                                .addGap(34, 34, 34)
                                                .addComponent(labPrcItem)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(labMontoItem)
                                                .addGap(46, 46, 46)
                                                .addComponent(labIndExe))
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(textMontoItem, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(42, 42, 42)
                                                .addComponent(chk_comboIndExe)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(labIndExe1)
                                            .addComponent(comboIndExe, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(dataGridDetalles_BotonAdicionar)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(dataGridDetalles_BotonEliminar)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(dataGridDetalles_BotonLimpiar))
                                    .addComponent(labReferencias)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(labTpoDocRef)
                                        .addGap(77, 77, 77)
                                        .addComponent(labFolioRef)
                                        .addGap(99, 99, 99)
                                        .addComponent(labFchRef)
                                        .addGap(18, 18, 18)
                                        .addComponent(labRazonRef)
                                        .addGap(104, 104, 104)
                                        .addComponent(labComentario))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabelLogo)
                                        .addGap(44, 44, 44)
                                        .addComponent(titularLabel))
                                    .addComponent(labEmisor1))
                                .addGap(0, 0, Short.MAX_VALUE)))
                        .addContainerGap())))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnSalvar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnCerrar)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(titularLabel)
                            .addComponent(jLabelLogo))
                        .addGap(18, 18, 18))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(labIpDteBox)
                            .addComponent(textIpDteBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(4, 4, 4)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labEmisor)
                    .addComponent(labCliente)
                    .addComponent(textLlaveAutenticacion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labLlaveAutenticacion))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labRUT)
                    .addComponent(textRUTEmisor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labRUTRecep)
                    .addComponent(textRUTRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labFolio)
                    .addComponent(textFolio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labRznSoc)
                    .addComponent(textRznSocEmis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labRznSocRecep)
                    .addComponent(textRznSocRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labFchEmis)
                    .addComponent(dateFchEmis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labGiroEmis)
                    .addComponent(textGiroEmis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labGiroRecep)
                    .addComponent(textGiroRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labMntNeto)
                    .addComponent(textMntNeto, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LabDirOrigen)
                    .addComponent(textDirOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labDirRecep)
                    .addComponent(textDirRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labIva)
                    .addComponent(textIva, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labCmnaOrigen)
                    .addComponent(textCmnaOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labCmnaRecep)
                    .addComponent(textCmnaRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labMntExe)
                    .addComponent(textMntExe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labCiudadOrigen)
                    .addComponent(textCiudadOrigen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labCiudadRecep)
                    .addComponent(textCiudadRecep, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labMntTotal)
                    .addComponent(textMntTotal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labActeco)
                    .addComponent(textActeco, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labTipoDTE)
                    .addComponent(comboTipoDTE, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(labActecoEjemplo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(labEmisor1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCdgItem)
                    .addComponent(labNmbItem)
                    .addComponent(labDscItem)
                    .addComponent(labUnmdItem)
                    .addComponent(labQtyItem)
                    .addComponent(labPrcItem)
                    .addComponent(labMontoItem)
                    .addComponent(labIndExe)
                    .addComponent(labIndExe1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(chk_comboIndExe)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(textCdgItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(textNmbItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(textDscItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(comboUnmdItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(textQtyItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(textPrcItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(textMontoItem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(comboIndExe, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(dataGridDetalles_BotonAdicionar)
                    .addComponent(dataGridDetalles_BotonEliminar)
                    .addComponent(dataGridDetalles_BotonLimpiar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(labReferencias)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labTpoDocRef)
                    .addComponent(labFolioRef)
                    .addComponent(labFchRef)
                    .addComponent(labRazonRef)
                    .addComponent(labComentario))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(comboTpoDocRef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(textFolioRef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(textRazonRef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(textComentarioRef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(dateFchRef, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(dataGridReferencia_BotonAdicionar)
                    .addComponent(dataGridReferencia_BotonEliminar)
                    .addComponent(dataGridReferencia_BotonLimpiar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCerrar)
                    .addComponent(btnSalvar))
                .addContainerGap(40, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Ejecuta la validación del formulario.
     * 
     * @return String con los mensajes de error producto de la validación
     */
    private String validarForm() {
        // validar la seccion de encabezado(emisor, cliente, totales)
        List secciones = new ArrayList();
        secciones.add("Encabezado");
        secciones.add("Detalles");
        String mensajesError = UtilIU.validarFormulario(this, secciones, definicionesValidacion);
        return mensajesError;
    }
    
    private void btnSalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalvarActionPerformed
        // TODO add your handling code here:
        // validar el formulario
        String mensajesError = validarForm();
        if (!mensajesError.isEmpty()) {
            JOptionPane.showConfirmDialog(this, mensajesError, "Errores de Validación", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                // Setear Valores IdDoc
                Date fecha = (Date) dateFchEmis.getValue();
                GregorianCalendar cal = (GregorianCalendar) GregorianCalendar.getInstance();
                cal.setTime(fecha);
                DateTime fechaEmis = new DateTime(cal, true);
                documento.setEncabezadoIdDoc(((InfoMostrar) comboTipoDTE.getSelectedItem()).getValor(), new BigInteger(textFolio.getText()), fechaEmis);
                
                // Setear valores Emisor
                documento.setEncabezadoEmisor(textRUTEmisor.getText(), textRznSocEmis.getText(),
                        textGiroEmis.getText(), textActeco.getText(), textDirOrigen.getText(), textCmnaOrigen.getText(), textCiudadOrigen.getText());
                
                // Setear valores Receptor
                documento.setEncabezadoReceptor(textRUTRecep.getText(), textRznSocRecep.getText(), textGiroRecep.getText(), 
                        textDirRecep.getText(),textCmnaRecep.getText(), textCiudadRecep.getText());
                
                // Setear valores totales
                BigInteger mntTotal = textMntTotal.getText().isEmpty() ? BigInteger.ZERO : new BigInteger(String.valueOf(textMntTotal.getText()));
                BigInteger mntExe = textMntExe.getText().isEmpty() ? BigInteger.ZERO : new BigInteger(String.valueOf(textMntExe.getText()));
                BigInteger mntNeto = textMntNeto.getText().isEmpty() ? BigInteger.ZERO : new BigInteger(String.valueOf(textMntNeto.getText()));
                BigInteger IVA = textIva.getText().isEmpty() ? BigInteger.ZERO : new BigInteger(String.valueOf(textIva.getText()));
                documento.setEncabezadoTotales(mntTotal, mntExe, mntNeto, IVA);
                
                SalvarDialog dialog = new SalvarDialog(null, true, documento, textIpDteBox.getText(), textLlaveAutenticacion.getText());
                dialog.setVisible(true);
                
            } catch (Exception ex) {
                Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showConfirmDialog(this, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_btnSalvarActionPerformed

    /**
     * Llena el formulario de entrada de referencias con el objeto referencia 
     * cuyo índice se pasa como parámetro.
     * 
     * @param indice índice del objeto referencia a cargar de la lista de referencias.
     */
    private void llenarFormReferencia(int indice) {
        try {
            Referencia ref = (Referencia)documento.getListaReferencias().get(indice);
            
            InfoMostrar tpoDocRef = new InfoMostrar(ref.getTpoDocRef(), "");
            comboTpoDocRef.setSelectedItem(tpoDocRef);
            textFolioRef.setText(ref.getFolioRef());
            dateFchRef.setText(String.valueOf(ref.getFchRef().getDay()) + "/" + String.valueOf(ref.getFchRef().getMonth()) + "/" + String.valueOf(ref.getFchRef().getYear()));
            textRazonRef.setText(ref.getRazonRef());
            textComentarioRef.setText("");
        } catch (LtException ex) {
            Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showConfirmDialog(this, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        }
    }
    
    /**
     * Limpia los controles para la entrada de las referencias.
     */
    private void limpiarFormReferencia() {
        comboTpoDocRef.setSelectedIndex(0);
        textFolioRef.setText("");
        dateFchRef.setValue(new Date());
        textRazonRef.setText("");
        textComentarioRef.setText("");
    }
    
    /**
     * Adiciona o actualiza una Referencia en la tabla de Referencias
     * 
     * @param indice
     * @throws LtException 
     */
    private void adicionarOActualizarReferenciaEnTabla(int indice) throws LtException {
        if (indice < 0) {
            Object[] datos = new Object[5];
            datos[0] = ((InfoMostrar) comboTpoDocRef.getSelectedItem()).getText();
            datos[1] = textFolioRef.getText();
            datos[2] = dateFchRef.getText();
            datos[3] = textRazonRef.getText();
            datos[4] = "";
            ((DefaultTableModel)dataGridReferencia.getModel()).addRow(datos);
        } else {
            dataGridReferencia.getModel().setValueAt(((InfoMostrar) comboTpoDocRef.getSelectedItem()).getText(), indice, 0);
            dataGridReferencia.getModel().setValueAt(textFolioRef.getText(), indice, 1);
            dataGridReferencia.getModel().setValueAt(dateFchRef.getText(), indice, 2);
            dataGridReferencia.getModel().setValueAt(textRazonRef.getText(), indice, 3);
        }
        limpiarFormReferencia();
        dataGridReferencia.clearSelection();
    }
    
    /**
     * Validar la sección de adicionar referencia del formulario.
     * 
     * @return String con los mensajes de errores producto de la validación
     */
    private String validarFormReferencia() {
        // validar la entrada de datos de la eseccion de detalle
        List secciones = new ArrayList();
        secciones.add("Referencia");
        String mensajesError = UtilIU.validarFormulario(this, secciones, definicionesValidacion);
        return mensajesError;
    }
    
    /**
     * Manejador del evento click del botón Adicionar de la tabla de Referencias.
     * Adiciona una Referencia a la tabla.
     * 
     * @param evt Evento
     */
    private void dataGridReferencia_BotonAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridReferencia_BotonAdicionarActionPerformed
        // TODO add your handling code here:
        
        // validar la entrada de datos
        String mensajesError = validarFormReferencia();
        if (!mensajesError.isEmpty()) {
            JOptionPane.showConfirmDialog(this, mensajesError, "Errores de Validación", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                Date fecha = (Date) dateFchRef.getValue();
                GregorianCalendar cal = (GregorianCalendar) GregorianCalendar.getInstance();
                cal.setTime(fecha);
                DateTime fechaReferencia = new DateTime(cal, true);
                int indice = 0;
                if (dataGridReferencia.getSelectedRowCount() > 0) {
                    // Editar
                    indice = dataGridReferencia.getSelectedRow();
                    documento.actualizarReferenciaEnIndice(((InfoMostrar) comboTpoDocRef.getSelectedItem()).getValor(), textFolioRef.getText(), fechaReferencia, textRazonRef.getText(), indice);
                } else {
                    // Adicionar
                    indice = -1;
                    documento.adicionarReferencia(((InfoMostrar) comboTpoDocRef.getSelectedItem()).getValor(), textFolioRef.getText(), fechaReferencia, textRazonRef.getText());
                }
                adicionarOActualizarReferenciaEnTabla(indice);
                
            } catch (Exception ex) {
                Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showConfirmDialog(this, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
            
        }
    }//GEN-LAST:event_dataGridReferencia_BotonAdicionarActionPerformed

    /**
     * Manejador del evento click del botón Limpiar de la tabla Referencias.
     * Limpia los controles para la entrada de referencias.
     * 
     * @param evt Evento
     */
    private void dataGridReferencia_BotonLimpiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridReferencia_BotonLimpiarActionPerformed
        // TODO add your handling code here:
        if (dataGridReferencia.getSelectedRowCount() > 0) {
            dataGridReferencia.clearSelection();
        } else {
            limpiarFormReferencia();
        }
    }//GEN-LAST:event_dataGridReferencia_BotonLimpiarActionPerformed

    /**
     * Manejador del evento click del botón Eliminar de la tabla Referencias.
     * Elimina la referencia seleccionada.
     * 
     * @param evt evento
     */
    private void dataGridReferencia_BotonEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridReferencia_BotonEliminarActionPerformed
        // TODO add your handling code here:
        if (UtilIU.confirmarEliminacionFilaGrid(this)) {
            try {
                if (dataGridReferencia.getSelectedRowCount() > 0) {
                    // Editar
                    int indice = dataGridReferencia.getSelectedRow();
                    ((DefaultTableModel) dataGridReferencia.getModel()).removeRow(indice);
                    documento.getListaReferencias().remove(indice);
                }
            } catch (Exception e) {
                Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, e);
                JOptionPane.showConfirmDialog(this, e.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
        }
        
        
    }//GEN-LAST:event_dataGridReferencia_BotonEliminarActionPerformed

    /**
     * Validar la sección de adicionar detalles del formulario.
     * 
     * @return String con los mensajes de errores producto de la validación
     */
    private String validarFormDetalle() {
        // validar la entrada de datos de la eseccion de detalle
        List secciones = new ArrayList();
        secciones.add("Detalle");
        String mensajesError = UtilIU.validarFormulario(this, secciones, definicionesValidacion);
        return mensajesError;
    }
    
    /**
     * Manejador del evento click del botón Adicionar de la tabla de Detalles.
     * Adiciona un Detalle a la tabla.
     * 
     * @param evt Evento
     */
    private void dataGridDetalles_BotonAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridDetalles_BotonAdicionarActionPerformed
        // TODO add your handling code here:
        // validar la entrada de datos
        String mensajesError = validarFormDetalle();
        if (!mensajesError.isEmpty()) {
            JOptionPane.showConfirmDialog(this, mensajesError, "Errores de Validación", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                InfoMostrar unmdItem = (InfoMostrar)comboUnmdItem.getSelectedItem();
                String valUnmdItem = unmdItem != null ? unmdItem.getValor() : "";
                String valIndExe = "";
                if (chk_comboIndExe.isSelected()) {
                    InfoMostrar indExe = (InfoMostrar)comboIndExe.getSelectedItem();
                    valIndExe = indExe != null ? indExe.getValor() : "";
                }
                List listaCdgItem = new ArrayList(); 
                if (!textCdgItem.getText().isEmpty()) {
                    listaCdgItem.add(documento.crearDetalleCdgItem("INT", textCdgItem.getText()));
                }
                
                int indice = 0;
                
                if (dataGridDetalles.getSelectedRowCount() > 0) {
                    // Editar
                    indice = dataGridDetalles.getSelectedRow();
                    documento.actualizarDetalleEnIndice(textNmbItem.getText(), new BigInteger(textMontoItem.getText()), 
                            valIndExe, textDscItem.getText(), new BigDecimal(textQtyItem.getText()), 
                            valUnmdItem, new BigDecimal(textPrcItem.getText()), listaCdgItem, indice);
                } else {
                    // Adicionar
                    indice = -1;
                    documento.adicionarDetalle(textNmbItem.getText(), new BigInteger(textMontoItem.getText()), 
                            valIndExe, textDscItem.getText(), new BigDecimal(textQtyItem.getText()), 
                            valUnmdItem, new BigDecimal(textPrcItem.getText()), listaCdgItem);
                }
                adicionarOActualizarDetalleEnTabla(indice);
                
            } catch (Exception ex) {
                Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showConfirmDialog(this, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
            
        }
    }//GEN-LAST:event_dataGridDetalles_BotonAdicionarActionPerformed

    /**
     * Manejador del evento click del botón Limpiar de la tabla Detalles.
     * Limpia los controles para la entrada de Detalles.
     * 
     * @param evt Evento
     */
    private void dataGridDetalles_BotonLimpiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridDetalles_BotonLimpiarActionPerformed
        // TODO add your handling code here:
        if (dataGridDetalles.getSelectedRowCount() > 0) {
            dataGridDetalles.clearSelection();
        } else {
            limpiarFormDetalle();
        }
    }//GEN-LAST:event_dataGridDetalles_BotonLimpiarActionPerformed
    
    /**
     * Manejador del evento click del botón Eliminar de la tabla Detalles.
     * Elimina el Detalle seleccionado.
     * 
     * @param evt evento
     */
    private void dataGridDetalles_BotonEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataGridDetalles_BotonEliminarActionPerformed
        // TODO add your handling code here:
        if (UtilIU.confirmarEliminacionFilaGrid(this)) {
            try {
                if (dataGridDetalles.getSelectedRowCount() > 0) {
                    // Editar
                    int indice = dataGridDetalles.getSelectedRow();
                    ((DefaultTableModel) dataGridDetalles.getModel()).removeRow(indice);
                    documento.getListaDetalles().remove(indice);
                }
            } catch (Exception e) {
                Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, e);
                JOptionPane.showConfirmDialog(this, e.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_dataGridDetalles_BotonEliminarActionPerformed

    /**
     * Activa o desactiva el combo de Indicador Exento en los detalles.
     * Si el chekbox chk_comboIndExe esta seleccionado se activa el combo sino
     * se desactiva.
     * 
     * @param evt evento
     */
    private void chk_comboIndExeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chk_comboIndExeActionPerformed
        // TODO add your handling code here:
        if (chk_comboIndExe.isSelected())
            comboIndExe.setEnabled(true);
        else
            comboIndExe.setEnabled(false);
    }//GEN-LAST:event_chk_comboIndExeActionPerformed

    private void btnCerrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCerrarActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
    }//GEN-LAST:event_btnCerrarActionPerformed

    /**
     * Calcula el monto de la linea de detalle al cambiar el valor del campo Cantidad.
     * 
     * @param evt 
     */
    private void textQtyItemPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textQtyItemPropertyChange
        // TODO add your handling code here:
        if (evt.getPropertyName().equals("value") && evt.getNewValue() != null && !evt.getNewValue().toString().isEmpty()) {
            if (!textPrcItem.getText().isEmpty()) {
                calcularMonto();
            }
        }
    }//GEN-LAST:event_textQtyItemPropertyChange

    /**
     * Calcula el monto de la linea de detalle al cambiar el valor del campo Precio.
     * 
     * @param evt 
     */
    private void textPrcItemPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textPrcItemPropertyChange
        // TODO add your handling code here:
        if (evt.getPropertyName().equals("value") && evt.getNewValue() != null && !evt.getNewValue().toString().isEmpty()) {
            if (!textQtyItem.getText().isEmpty()) {
                calcularMonto();
            }
        }
    }//GEN-LAST:event_textPrcItemPropertyChange

    /**
     * Calcula el monto de la linea de detalle.
     */
    private void calcularMonto() {
        BigDecimal cantidad = new BigDecimal(textQtyItem.getText());
        BigDecimal precio = new BigDecimal(textPrcItem.getText());
        textMontoItem.setText(String.valueOf(cantidad.multiply(precio).setScale(0, RoundingMode.UP).longValue()));
    }
    
    /**
     * Llena el formulario de entrada de Detalles con el objeto Detalle seleccionado 
     * cuyo índice se pasa como parámetro.
     * 
     * @param indice índice del objeto Detalle a cargar de la lista de Detalles.
     */
    private void llenarFormDetalle(int indice) {
        try {
            Detalle det = (Detalle)documento.getListaDetalles().get(indice);
            
            InfoMostrar unmdItem = new InfoMostrar(det.getUnmdItem(), "");
            comboUnmdItem.setSelectedItem(unmdItem);
            
            if (det.isValidIndExe()) {
                InfoMostrar indExe = new InfoMostrar(det.getIndExe().toString(), "");
                chk_comboIndExe.setSelected(true);
                comboIndExe.setSelectedItem(indExe);
            } else {
                chk_comboIndExe.setSelected(false);
                comboIndExe.setSelectedIndex(0);
            }
            this.chk_comboIndExeActionPerformed(null);
            
            if (det.getCdgItem().count() > 0) {
                textCdgItem.setText(det.getCdgItem().getItem(0).getVlrCodigo());
            } else {
                textCdgItem.setText("");
            }
            textNmbItem.setText(det.getNmbItem());
            textDscItem.setText(det.getDscItem());
            textQtyItem.setText(det.getQtyItem().toString());
            textPrcItem.setText(det.getPrcItem().toString());
            textMontoItem.setText(det.getMontoItem().toString());
        } catch (LtException ex) {
            Logger.getLogger(DocumentoJInternalFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showConfirmDialog(this, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        }
    }
    
    /**
     * Limpia los controles para la entrada de los Detalles.
     */
    private void limpiarFormDetalle() {
        textCdgItem.setText("");
        textNmbItem.setText("");
        textDscItem.setText("");
        textQtyItem.setText("");
        textPrcItem.setText("");
        textMontoItem.setText("");
        comboUnmdItem.setSelectedIndex(0);
        chk_comboIndExe.setSelected(false);
        this.chk_comboIndExeActionPerformed(null);
        comboIndExe.setSelectedIndex(0);
    }
    
    /**
     * Adiciona o actualiza un Detalle en la tabla de Detalles
     * 
     * @param indice indice del Detalle a actualizar
     * @throws LtException 
     */
    private void adicionarOActualizarDetalleEnTabla(int indice) throws LtException {
        String valUnmdItem = "";
        String valIndExe = "";
        if (comboUnmdItem.getSelectedItem() != null) {
            valUnmdItem = ((InfoMostrar) comboUnmdItem.getSelectedItem()).getText();
        }
        if (chk_comboIndExe.isSelected() && comboIndExe.getSelectedItem() != null) {
            valIndExe = ((InfoMostrar) comboIndExe.getSelectedItem()).getText();
        }
        
        if (indice < 0) {
            Object[] datos = new Object[8];
            datos[0] = textCdgItem.getText();
            datos[1] = textNmbItem.getText();
            datos[2] = textDscItem.getText();
            datos[3] = valUnmdItem;
            datos[4] = textQtyItem.getText();
            datos[5] = textPrcItem.getText();
            datos[6] = textMontoItem.getText();
            datos[7] = valIndExe;
            ((DefaultTableModel)dataGridDetalles.getModel()).addRow(datos);
        } else {
            dataGridDetalles.getModel().setValueAt(textCdgItem.getText(), indice, 0);
            dataGridDetalles.getModel().setValueAt(textNmbItem.getText(), indice, 1);
            dataGridDetalles.getModel().setValueAt(textDscItem.getText(), indice, 2);
            dataGridDetalles.getModel().setValueAt(valUnmdItem, indice, 3);
            dataGridDetalles.getModel().setValueAt(textQtyItem.getText(), indice, 4);
            dataGridDetalles.getModel().setValueAt(textPrcItem.getText(), indice, 5);
            dataGridDetalles.getModel().setValueAt(textMontoItem.getText(), indice, 6);
            dataGridDetalles.getModel().setValueAt(valIndExe, indice, 7);
        }
        
        limpiarFormDetalle();
        dataGridDetalles.clearSelection();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel LabDirOrigen;
    private javax.swing.JButton btnCerrar;
    private javax.swing.JButton btnSalvar;
    private javax.swing.JCheckBox chk_comboIndExe;
    private javax.swing.JComboBox comboIndExe;
    private javax.swing.JComboBox comboTipoDTE;
    private javax.swing.JComboBox comboTpoDocRef;
    private javax.swing.JComboBox comboUnmdItem;
    private javax.swing.JTable dataGridDetalles;
    private javax.swing.JButton dataGridDetalles_BotonAdicionar;
    private javax.swing.JButton dataGridDetalles_BotonEliminar;
    private javax.swing.JButton dataGridDetalles_BotonLimpiar;
    private javax.swing.JTable dataGridReferencia;
    private javax.swing.JButton dataGridReferencia_BotonAdicionar;
    private javax.swing.JButton dataGridReferencia_BotonEliminar;
    private javax.swing.JButton dataGridReferencia_BotonLimpiar;
    private javax.swing.JFormattedTextField dateFchEmis;
    private javax.swing.JFormattedTextField dateFchRef;
    private javax.swing.JLabel jLabelLogo;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel labActeco;
    private javax.swing.JLabel labActecoEjemplo;
    private javax.swing.JLabel labCiudadOrigen;
    private javax.swing.JLabel labCiudadRecep;
    private javax.swing.JLabel labCliente;
    private javax.swing.JLabel labCmnaOrigen;
    private javax.swing.JLabel labCmnaRecep;
    private javax.swing.JLabel labComentario;
    private javax.swing.JLabel labDirRecep;
    private javax.swing.JLabel labDscItem;
    private javax.swing.JLabel labEmisor;
    private javax.swing.JLabel labEmisor1;
    private javax.swing.JLabel labFchEmis;
    private javax.swing.JLabel labFchRef;
    private javax.swing.JLabel labFolio;
    private javax.swing.JLabel labFolioRef;
    private javax.swing.JLabel labGiroEmis;
    private javax.swing.JLabel labGiroRecep;
    private javax.swing.JLabel labIndExe;
    private javax.swing.JLabel labIndExe1;
    private javax.swing.JLabel labIpDteBox;
    private javax.swing.JLabel labIva;
    private javax.swing.JLabel labLlaveAutenticacion;
    private javax.swing.JLabel labMntExe;
    private javax.swing.JLabel labMntNeto;
    private javax.swing.JLabel labMntTotal;
    private javax.swing.JLabel labMontoItem;
    private javax.swing.JLabel labNmbItem;
    private javax.swing.JLabel labPrcItem;
    private javax.swing.JLabel labQtyItem;
    private javax.swing.JLabel labRUT;
    private javax.swing.JLabel labRUTRecep;
    private javax.swing.JLabel labRazonRef;
    private javax.swing.JLabel labReferencias;
    private javax.swing.JLabel labRznSoc;
    private javax.swing.JLabel labRznSocRecep;
    private javax.swing.JLabel labTipoDTE;
    private javax.swing.JLabel labTpoDocRef;
    private javax.swing.JLabel labUnmdItem;
    private javax.swing.JLabel lblCdgItem;
    private javax.swing.JTextField textActeco;
    private javax.swing.JTextField textCdgItem;
    private javax.swing.JTextField textCiudadOrigen;
    private javax.swing.JTextField textCiudadRecep;
    private javax.swing.JTextField textCmnaOrigen;
    private javax.swing.JTextField textCmnaRecep;
    private javax.swing.JTextField textComentarioRef;
    private javax.swing.JTextField textDirOrigen;
    private javax.swing.JTextField textDirRecep;
    private javax.swing.JTextField textDscItem;
    private javax.swing.JFormattedTextField textFolio;
    private javax.swing.JTextField textFolioRef;
    private javax.swing.JTextField textGiroEmis;
    private javax.swing.JTextField textGiroRecep;
    private javax.swing.JTextField textIpDteBox;
    private javax.swing.JFormattedTextField textIva;
    private javax.swing.JTextField textLlaveAutenticacion;
    private javax.swing.JFormattedTextField textMntExe;
    private javax.swing.JFormattedTextField textMntNeto;
    private javax.swing.JFormattedTextField textMntTotal;
    private javax.swing.JFormattedTextField textMontoItem;
    private javax.swing.JTextField textNmbItem;
    private javax.swing.JFormattedTextField textPrcItem;
    private javax.swing.JFormattedTextField textQtyItem;
    private javax.swing.JTextField textRUTEmisor;
    private javax.swing.JTextField textRUTRecep;
    private javax.swing.JTextField textRazonRef;
    private javax.swing.JTextField textRznSocEmis;
    private javax.swing.JTextField textRznSocRecep;
    private javax.swing.JLabel titularLabel;
    // End of variables declaration//GEN-END:variables

    
}
