/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gdexpress.demofacturador.vista;

import com.liquid_technologies.ltxmllib12.exceptions.LtException;
import dteboxcliente.Ambiente;
import dteboxcliente.ResultadoEnvio;
import dteboxcliente.ResultadoEnvioDocumento;
import dteboxcliente.Servicio;
import dteboxcliente.TipoPDF417;
import gdexpress.demofacturador.lib.Boleta;
import gdexpress.demofacturador.lib.Documento;
import gdexpress.demofacturador.lib.Exportaciones;
import gdexpress.demofacturador.lib.IFactura;
import gdexpress.demofacturador.lib.Liquidacion;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;

/**
 *
 * @author yrios
 */
public class SalvarDialog extends javax.swing.JDialog {

    /**
     * A return status code - returned if Cancel button has been pressed
     */
    public static final int RET_CANCEL = 0;
    /**
     * A return status code - returned if OK button has been pressed
     */
    public static final int RET_OK = 1;

    /**
     * Factura a enviar al DTEBox.
     */
    private IFactura factura;
    
    /**
     * Dirección ip o nombre del servidor del DTEBox.
     */
    private String ipDTEBox;
    
    /**
     * Llave de Autenticación para la conección al DTEBox.
     */
    private String llaveAutenticacion;
    
    /**
     * Creates new form SalvarDialog
     */
    public SalvarDialog(java.awt.Frame parent, boolean modal, IFactura factura, String ipDTEBox, String llaveAutenticacion) {
        super(parent, modal);
        initComponents();

        // Close the dialog when Esc is pressed
        String cancelName = "cancel";
        InputMap inputMap = getRootPane().getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), cancelName);
        ActionMap actionMap = getRootPane().getActionMap();
        actionMap.put(cancelName, new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                doClose(RET_CANCEL);
            }
        });
        
        this.factura = factura;
        this.ipDTEBox = ipDTEBox;
        this.llaveAutenticacion = llaveAutenticacion;
        String xmlFactura = obtenerXML();
        textXMLFactura.setText(xmlFactura);
    }

    /**
     * Obtiene el XML de la factura.
     * 
     * @return String con el XML de la factura
     */
    private String obtenerXML() {
        try {
            return factura.obtenerXML();
        } catch (Exception ex) {
            Logger.getLogger(SalvarDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showConfirmDialog(null, ex.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        }
        return "";
    }
    
    /**
     * @return the return status of this dialog - one of RET_OK or RET_CANCEL
     */
    public int getReturnStatus() {
        return returnStatus;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnSalvar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        textXMLFactura = new javax.swing.JTextArea();

        setTitle("XML generado");
        setModal(true);
        setName("dialogoSalvar"); // NOI18N
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        btnSalvar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/semaforo_green.png"))); // NOI18N
        btnSalvar.setText("Enviar al DTEBox");
        btnSalvar.setName("btnSalvar"); // NOI18N
        btnSalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalvarActionPerformed(evt);
            }
        });

        btnCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gdexpress/demofacturador/vista/imagenes/cross.png"))); // NOI18N
        btnCancelar.setText("Cancelar");
        btnCancelar.setName("btnCancelar"); // NOI18N
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        textXMLFactura.setEditable(false);
        textXMLFactura.setColumns(20);
        textXMLFactura.setRows(5);
        textXMLFactura.setName("textXMLFactura"); // NOI18N
        jScrollPane1.setViewportView(textXMLFactura);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 546, Short.MAX_VALUE)
                        .addComponent(btnSalvar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancelar))
                    .addComponent(jScrollPane1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 547, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancelar)
                    .addComponent(btnSalvar))
                .addContainerGap())
        );

        getRootPane().setDefaultButton(btnSalvar);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnSalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalvarActionPerformed
        //doClose(RET_OK);
        try {
            // Llamada al servicio
            String ambiente = Ambiente.Homologacion;
            String fechaResolucion = "2010-01-01";
            int numeroResolucion = 10;
            int tipoPdf417 = TipoPDF417.Fuente;
            String apiURL = "http://<DTEBox IP>/api/Core.svc/Core".replace("<DTEBox IP>", ipDTEBox);
            String apiAuth = llaveAutenticacion;
            Servicio servicio = new Servicio(apiURL, apiAuth);
            
            ResultadoEnvioDocumento resultadoEnvioDocumento = null;
            
            int resultado = 0;
            
            if (factura instanceof Documento) {
                resultadoEnvioDocumento = servicio.EnviarDocumento(((Documento)factura).getDte(), ambiente, fechaResolucion, numeroResolucion, tipoPdf417);
                resultado = resultadoEnvioDocumento.getResultadoServicio().getEstado();
            } else if (factura instanceof Exportaciones) {
                resultadoEnvioDocumento = servicio.EnviarDocumento(((Exportaciones)factura).getDte(), ambiente, fechaResolucion, numeroResolucion, tipoPdf417);
                resultado = resultadoEnvioDocumento.getResultadoServicio().getEstado();
            } else if (factura instanceof Liquidacion) {
                resultadoEnvioDocumento = servicio.EnviarDocumento(((Liquidacion)factura).getDte(), ambiente, fechaResolucion, numeroResolucion, tipoPdf417);
                resultado = resultadoEnvioDocumento.getResultadoServicio().getEstado();
            } else if (factura instanceof Boleta) {
                resultadoEnvioDocumento = servicio.EnviarDocumento(((Boleta)factura).getDte(), ambiente, fechaResolucion, numeroResolucion, tipoPdf417);
                resultado = resultadoEnvioDocumento.getResultadoServicio().getEstado();
            }
            
            // Procesar Resultado
            //Si la respuesta es correcta
            if (resultado == 0) {
                //Código de usuario a partir de aquí
                JOptionPane.showConfirmDialog(this, "Factura enviada correctamente al DTEBox", "Información", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
            } else {
                String error = resultadoEnvioDocumento.getResultadoServicio().getDescripcion();
                JOptionPane.showConfirmDialog(this, error, "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
            }
            
        } catch (Exception e) {
            Logger.getLogger(SalvarDialog.class.getName()).log(Level.SEVERE, null, e);
            JOptionPane.showConfirmDialog(this, e.getMessage(), "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btnSalvarActionPerformed
    
    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_btnCancelarActionPerformed

    /**
     * Closes the dialog
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog
    
    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        /*try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(SalvarDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(SalvarDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(SalvarDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(SalvarDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }*/
//        //</editor-fold>
//
//        /* Create and display the dialog */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                SalvarDialog dialog = new SalvarDialog(new javax.swing.JFrame(), true);
//                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
//                    
//                    public void windowClosing(java.awt.event.WindowEvent e) {
//                        System.exit(0);
//                    }
//                });
//                dialog.setVisible(true);
//            }
//        });
//    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnSalvar;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea textXMLFactura;
    // End of variables declaration//GEN-END:variables
    private int returnStatus = RET_CANCEL;
}
