/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gdexpress.demofacturador.vista;

import java.util.HashMap;

/**
 * Clase para definir las reglas de validación a realizar a un campo en la interfaz de usuario.
 *
 * @author yrios
 */
public class Validacion {
    /**
     * Label del campo, se usa en el mensaje mostrado al usuario al ocurrir un error de validación.
     */
    private String labelCampo;
    
    /**
     * Sección de la interfaz de usuario en la que se encuentra el campo. Esto permite realizar validaciones por secciones.
     */
    private String seccion;
    
    /**
     * Reglas de validación a aplicar al campo.
     * Ejemplo: Reglas = new Dictionary<string, object> { {"req", true}, {"rut", true} }}}
     * Reglas = new Dictionary<string, object> { {"req", true}, {"num", true}, {"min", new decimal(0.000001)} }
     * req: requerido
     * num: numérico
     * min: valor mínimo
     */
    private HashMap reglas;

    public Validacion(String labelCampo, String seccion, HashMap reglas) {
        this.labelCampo = labelCampo;
        this.seccion = seccion;
        this.reglas = reglas;
    }

    public String getLabelCampo() {
        return labelCampo;
    }

    public void setLabelCampo(String labelCampo) {
        this.labelCampo = labelCampo;
    }

    public String getSeccion() {
        return seccion;
    }

    public void setSeccion(String seccion) {
        this.seccion = seccion;
    }

    public HashMap getReglas() {
        return reglas;
    }

    public void setReglas(HashMap reglas) {
        this.reglas = reglas;
    }
    
}
